      subroutine activateWindow(nr,ier)
      integer   nr
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='ActivateWindow')
      call CheckWindowNr(nr,ROUTINE,ier)
      if(ier.ne.0) return
      if(nr.eq.ActiveWindow) then
        call WindowLogInteger(wLogInfo,nr,'Window # already active.')
        ier = 0
        return
      endif
      if(ActiveWorld.gt.0) then
        call WindowLogInteger(wLogInfo,ActiveWorld,
     +       'Deactivating World #.')
        ActiveWorld = -1
      endif
      ActiveWindow = nr
      if(IsPixmap(nr)) then
        call WindowLogInteger(wLogInfo,nr,'Activating Pixmap #.')
        call pactivate(ActiveWindow)
      else
        call WindowLogInteger(wLogInfo,nr,'Activating Window #.')
        call wactivate(ActiveWindow)
      endif
      ier = 0
      return
      end                       ! ActivateWindow
      subroutine ActivateWorld(nr,ier)
      integer   nr
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='ActivateWorld')
      if(nr.eq.ActiveWorld) then
        call WindowLogInteger(wLogInfo,nr,'World # already active.')
        ier = 0
      endif
      call WindowLogInteger(wLogInfo,nr,'Activating World #.')
      if(nr.ge.1.and.nr.le.MaxWorld) then
        call activateWindow(WorldParent(nr),ier)
        if(ier.ne.0) then
          activeworld = -1
          call windowlogError(ROUTINE,nr,
     +         'world # has no corresponding window.')
          return
        endif
        ActiveWorld = nr
        call windowloginteger(wLogInfo,ActiveWorld,'Active World=#.')
        ier = 0
      else
        call windowlogerror(ROUTINE,nr,'# out of range.')
        ier = 1
        ActiveWorld = -1
      endif
      return
      end                       ! ActivateWorld
      subroutine AddPoint(x,y)
      real      x
      real      y
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='AddPoint')
      integer   nx
      integer   ny
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x,y,nx,ny,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x,y,nx,ny)
        return
      endif
      call AddWindowPoint(nx,ny)
      return
      end                       ! AddPoint
      subroutine AddWindowPoint(nx,ny)
      integer   nx
      integer   ny
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external  windowdata
      if(ipoint.ge.maxpoint) then
        if(PointMode.eq.1) then
          call DrawWindowPoints
          ipoint = 0
        else if(pointmode.eq.2.or.pointmode.eq.3) then
          call DrawWindowLines
          pointxy(1) = pointxy(2*ipoint-1) ! start at the last point
          pointxy(2) = pointxy(2*ipoint)
          ipoint = 1
        endif
      endif
      if(ipoint.lt.maxpoint) then
        ipoint = ipoint + 1
        pointxy(2*ipoint-1) = int2(nx)
        pointxy(2*ipoint) = int2(ny)
        if(ipoint.eq.1.and.pointmode.eq.3) then
          firstpoint(1) = pointxy(1)
          firstpoint(2) = pointxy(2)
        endif
      endif
      return
      end                       ! AddWindowPoint
      subroutine CalculateWorld(llx,lly,urx,ury)
      real llx
      real lly
      real urx
      real ury
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      scalx(ActiveWorld) = (WindowWidth(ActiveWindow)-1)/(urx-llx)
      scaly(ActiveWorld) = (WindowHeight(ActiveWindow)-1)/(ury-lly)
      offsx(ActiveWorld) = llx
      offsy(ActiveWorld) = lly
      topx(ActiveWorld) = urx
      topy(ActiveWorld) = ury
      if(loglevel.ge.wLogNotice) then
        call str_2real_out(scalx(ActiveWorld),scaly(ActiveWorld),
     +       'Scale # #')
        call str_2real_out(offsx(ActiveWorld),offsy(ActiveWorld),
     +       'LL # #')
        call str_2real_out(topx(ActiveWorld),topy(ActiveWorld),
     +       'UR # #.')
        call str_flush
      endif
      return
      end                       ! CalculateWorld
      subroutine CheckPixmapNr(p,calledfrom,ier)
      integer   p
      character calledfrom*(*)
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      call CheckWindowNr(p,calledfrom,ier)
      if(ier.ne.0) return
      if(.not.IsPixmap(p)) then
        call WindowLogError(calledfrom,p,
     +       'Error: pixmap # is not a pixmap.')
        ier = 1
      endif
      return
      end                       ! CheckPixmap
      subroutine CheckWindowNr(nr,routine,ier)
      integer   nr
      character routine*(*)
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      call GetWindowStatus(nr,ier)
      if(ier.lt.0) then
        call windowlogError(ROUTINE,nr,'nr # out of range.')
      else if(ier.gt.0) then
        call WindowLogError(ROUTINE,nr,'Window # does not exist.')
      endif
      return
      end                       ! CheckWindowNr
      subroutine ClearPoint(n)
      integer   n
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      PointMode = n
      ipoint = 0
      return
      end                       ! ClearPoint
      subroutine ClearWindow
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='ClearWindow')
      if(ActiveWindow.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      if(ActiveWindow.gt.0) then
        if(IsPixmap(ActiveWindow)) then
          call SetColourDirect(WindowBG(ActiveWindow))
          if(loglevel.ge.wLogNotice) then
            call str_integer_out(activeWindow,'Cleared pixmap #')
            call str_integer_out(WindowWidth(activeWindow),'width #')
            call str_integer_out(WindowHeight(activeWindow),'height #.')
          endif
          call wfillrectangle(0,0,WindowWidth(ActiveWindow),
     +         WindowHeight(ActiveWindow))
        else
          if(loglevel.ge.wLogNotice) then
            call str_integer_out(ActiveWindow,'Cleared Window #.')
          endif
          call wclear
        endif
        LastColourCode = -1
        LastColourName = ' '
        LastColourSet = -1
      endif
      return
      end                       ! ClearWindow
      subroutine CreatePixmap(pnr,wnr,ier)
      integer   pnr
      integer   wnr
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='CreatePixmap')
      if(loglevel.ge.wLogNotice) then
        call str_flush
        call str_out(ROUTINE)
        call str_integer_out(pnr,'#')
        call str_integer_out(wnr,'on window #')
      endif
      if(pnr.le.0.or.pnr.gt.maxwindow) then
        call windowlogerror(ROUTINE,pnr,'nr # out of range.')
        ier = 1
        return
      endif
      if(WindowUsed(pnr)) then
        call DeleteWindow(pnr,ier)
        if(ier.ne.0) return
      endif
      call ActivateWindow(wnr,ier)
      if(ier.ne.0) return
      WindowUsed(pnr) = .true.
      WindowWidth(pnr)  = WindowWidth(wnr)
      WindowHeight(pnr) = WindowHeight(wnr)
      WindowHor(pnr) = WindowHor(wnr)
      WindowVer(pnr) = WindowVer(wnr)
      WindowVerX(pnr) = WindowVerx(wnr)
      WindowBG(pnr) = WindowBG(wnr)
      WindowParent(pnr) = wnr
      IsPixmap(pnr) = .true.
      call wpixmap(pnr,wnr,WindowWidth(pnr),windowheight(pnr))
      if(loglevel.ge.wLogNotice) then
        call str_integer_out(pnr,'pixmap # created.')
      endif
      call ActivateWindow(pnr,ier)
      call ClearWindow
      ier = 0
      return
      end                       ! CreatePixmap
      subroutine CreateSubWindow(nr1,nr2,llx,lly,sx,sy,border,
     +     colour,ier)
      integer   nr1
      integer   nr2
      integer   llx
      integer   lly
      integer   sx
      integer   sy
      integer   border
      character colour*(*)
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='CreateSubWindow')
      integer   bg
      if(loglevel.ge.wLogNotice) then
        call str_flush
        call str_out(ROUTINE)
        call str_integer_out(nr1,'#')
        call str_integer_out(nr2,'on #')
        call str_2integer_out(llx,lly,'LL= #,#')
        call str_2integer_out(sx,sy,'Size= #,#')
        call str_integer_out(border,'border=#')
        call str_string_out(colour,'bgcolour=#.')
        call str_flush
      endif
      if(nr1.gt.maxwindow) then
        call WindowLogError(ROUTINE,nr1,'# out of range.')
        ier = 1
        return
      endif
      call CheckWindowNr(nr2,ROUTINE,ier)
      if(ier.ne.0) return
      if(WindowUsed(nr1)) then
        call DeleteWindow(nr1,ier)
        if(ier.ne.0) return
        call WindowFlush ! xxxxxxxxxxxxxxxxxxxx
      endif
      WindowWidth(nr1)  = sx
      WindowHeight(nr1) = sy
      WindowParent(nr1) = nr2
      WindowHor(nr1) = llx
      WindowVer(nr1) = lly
      WindowVerX(nr1) = WindowHeight(nr2) - lly - sy - (2*border)
      WindowBorder(nr1) = border
      if(loglevel.ge.wLogInfo) then
        call str_3integer_out(WindowHor(nr1),WindowVer(nr1),
     +       WindowVerX(nr1),'Hor=# Ver=# VerX=#')
        call str_2integer_out(WindowWidth(nr1),WindowHeight(nr1),
     +       'w=# h=#.')
      endif
      call GetColour(colour,bg)
      if(loglevel.ge.wLOgDebug) call str_out('before wopen')
      call wactivate(nr2)
      call wsubopen(nr1,WindowHor(nr1),WindowVerX(nr1),
     +     WindowWidth(nr1),WindowHeight(nr1),border,bg)
      if(loglevel.ge.wLogDebug) call str_out('after wopen')
      WindowUsed(nr1) = .true.
      WindowBG(nr1) = bg
      activewindow = -1
      call ActivateWindow(nr1,ier)
      if(loglevel.ge.wLogNotice) then
        call str_flush
      endif
      call WindowFlush
      ier = 0
      return
      end                       ! CreateSubWindow
      subroutine CreateUnitWorld(nr,windownr,ier)
      integer   nr       ! world number
      integer   WindowNr ! window number
      integer   ier
      call CreateWorld(nr,windownr,0.0,0.0,1.0,1.0,ier)
      return
      end                       ! CreateUnitWorld
      subroutine CreateWindow(nr,title,llx,lly,sx,sy,colour,ToMap,ier)
      integer   nr
      character title*(*)
      integer   llx
      integer   lly
      integer   sx
      integer   sy
      character colour*(*)
      logical   ToMap
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='CreateWindow')
      integer   length
      character name*80
      integer   ln
      integer   lt
      integer   bg
      integer   fg
      call InitWindow(ier)
      if(ier.ne.0) return
      if(loglevel.ge.wLogNotice) then
        call str_flush
        call str_out(ROUTINE)
        call str_integer_out(nr,'#')
        call str_out(title)
        call str_2integer_out(llx,lly,'LL= #,#')
        call str_2integer_out(sx,sy,'Size= #,#')
        call str_string_out(colour,'bgcolour=#')
      endif
      if(nr.gt.maxwindow) then
        call windowlogerror(ROUTINE,nr,'nr # out of range.')
        ier = 1
        return
      endif
      if(WindowUsed(nr)) then
        call DeleteWindow(nr,ier)
        if(ier.ne.0) return
      endif
      WindowWidth(nr)  = sx
      WindowHeight(nr) = sy
      WindowHor(nr) = llx
      WindowVer(nr) = lly
      WindowVerX(nr) = ScreenHeight - WindowVer(nr) - sy
      WindowParent(nr) = 0
      WindowBorder(nr) = 0
      IsPixmap(nr) = .false.
      if(loglevel.ge.wLogInfo) then
        call str_3integer_out(WindowHor(nr),WindowVer(nr),
     +       WindowVerX(nr),'Hor=# Ver=# VerX=#')
        call str_2integer_out(WindowWidth(nr),WindowHeight(nr),
     +       'w=# h=#.')
      endif
      call GetColour(colour,bg)
      call GetColour('white',fg)
      if(loglevel.ge.wLogDebug) call str_out('before wopen')
      call wopen(nr,WindowHor(nr),WindowVerX(nr),WindowWidth(nr),
     +     WindowHeight(nr),fg,bg)
      if(loglevel.ge.wLogDebug) call str_out('after wopen')
      WindowUsed(nr) = .true.
      ActiveWindow = nr
      if(ToMap) then
        call MapWindow(nr,ier)
        if (LogLevel.ge.wLogDebug) call str_out('and MapWindow')
      endif
      WindowBG(nr) = bg
      lt = length(title)
      if(lt.eq.0) then
        call image_name(name,ln)
      else
        name = title
        ln = lt
      endif
      call str_zero(name,name,ln)
      call wtitle(name(1:ln))
      if(loglevel.ge.wLogNotice) then
        call str_flush
      endif
      activewindow = -1
      call ActivateWindow(nr,ier)
      ier = 0
      call WindowFlush
      return
      end                       ! CreateWindow
      subroutine CreateWorld(nr,windownr,llx,lly,urx,ury,ier)
      integer   nr       ! world number
      integer   WindowNr ! window number
      real      llx      ! world x coordinate Lower Left
      real      lly      ! world y coordinate Lower Left
      real      urx      ! world x coordinate Upper Right
      real      ury      ! world y coordinate Upper Right
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='CreateWorld')
      if(nr.gt.MaxWorld) then
        call WindowLogError(ROUTINE,nr,'# out of range.')
        ier = 1
        return
      endif
      if(.not.WindowUsed(WindowNr)) then
        call WindowLogError(ROUTINE,nr,'#')
        call WindowLogInteger(wLOgErr,windownr,
     +       'Window # is not available.')
        ier = 1
        return
      endif
      if(loglevel.ge.wLOgNotice) then
        call str_flush
        call str_out(ROUTINE)
        call str_integer_out(nr,'#')
        if(IsPixmap(WindowNr)) then
          call str_integer_out(windownr,'on pixmap #')
        else
          call str_integer_out(windownr,'on window #')
        endif
        call str_2real_out(llx,lly,'LL=# #')
        call str_2real_out(urx,ury,'UR=# #')
        call str_integer_out(windowwidth(WindowNr),'w=#')
        call str_integer_out(windowheight(WindowNr),'h=#')
      endif
      if(urx-llx.eq.0.0.or.ury-lly.eq.0.0) then
        call WindowLogError(ROUTINE,nr,'world #')
        call WindowLogInteger(wLOgErr,windownr,'window #.')
        if(urx-llx.eq.0.0) then
          call WindowLog(wLogErr,'zero horizontal range.')
        endif
        if(ury-lly.eq.0.0) then
          call WindowLog(wLogErr,'zero vertical range.')
        endif
        ier = 1
        return
      endif
      WorldParent(nr) = WindowNr
      call ActivateWorld(nr,ier)
      call CalculateWorld(llx,lly,urx,ury)
      return
      end                       ! CreateWorld
      subroutine DeleteWindow(nr,ier)
      integer   nr
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DeleteWindow')
      if(nr.le.0.or.nr.gt.maxwindow) then
        call windowlogError(ROUTINE,nr,'nr # out of range.')
        ier = 1
        return
      endif
      call DeleteWindowDaughters(nr,.true.,ier)
      ier = 0
      return
      end                       ! deleteWindow
      subroutine DeleteWindowDaughters(nr,ParentAlso,ier)
      integer   nr
      logical   ParentAlso
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DeleteWindowDaughters')
      integer   i
      integer   todo(maxwindow)
      integer   ntodo
      integer   lastfrom
      integer   lasttodo
      integer   j
      integer   lowbound
      if(nr.le.0.or.nr.gt.maxwindow) then
        call windowlogError(ROUTINE,nr,'nr # out of range.')
        ier = 1
        return
      endif
      if(loglevel.ge.wLogNotice) then
        call str_flush
        call str_out(ROUTINE)
        call str_integer_out(nr,'window #')
        call str_logical_out(ParentAlso,'ParentAlso=#')
      endif
      ier = 0
      if(WindowUsed(nr)) then
        ntodo = 1
        todo(ntodo) = nr
        lasttodo = 0
   10   continue
        lastfrom = lasttodo+1
        lasttodo = ntodo
        do i=1,maxwindow
          if(WindowUsed(i)) then
            do j=lastfrom,lasttodo
              if(WindowParent(i).eq.todo(j)) then
                ntodo = ntodo + 1
                if(ntodo.gt.maxwindow) then
                  call WindowLog(wLogEmerg,'Overflow in DeleteWindow')
                  call exitfatal
                endif
                todo(ntodo) = i
              endif
            enddo
          endif
        enddo
        if(ntodo.gt.lasttodo) goto 10
        if(loglevel.ge.wLogNotice) then
          do i=1,ntodo
            call str_integer_out(todo(i),'#')
          enddo
        endif
        if(ParentAlso) then
          LowBound = 1
        else
          LowBound = 2
        endif
        do i=ntodo,LowBound,-1
          j = todo(i)
          if(IsPixmap(j)) then
            call WindowLogInteger(wLogNotice,j,'Deleted pixmap #.')
            call pdelete(j)
          else
            call WindowLogInteger(wLogNotice,j,'Deleted window #.')
            call wclose(j)
          endif
          WindowUsed(j) = .false.
        enddo
        do i=1,maxworld
           if(WorldParent(i).gt.0) then
              if(.not.WindowUsed(WorldParent(i))) then
                 WorldParent(i) = 0
              endif
           endif
        enddo
        if(.not.WindowUsed(ActiveWorld)) ActiveWorld = -1
        if(.not.WindowUsed(ActiveWindow)) ActiveWindow = -1
      endif
      return
      end                       ! DeleteWindowDaughters
      subroutine DrawArc(x,y,radius,start,size)
      real      x
      real      y
      real      radius
      real      start  ! radians
      real      size ! radians
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawArc')
      real      Pi
      real      Grad
      parameter (Pi=3.1415927)
      parameter (Grad = 180.0/Pi)
      integer   nx
      integer   ny
      integer   hx,hy
      integer   halfrad
      integer   fullrad
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x,y,nx,ny,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x,y,nx,ny)
        return
      endif
      call WorldToWindow(x+radius,y,hx,hy,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x+radius,y,hx,hy)
        return
      endif
      halfrad = abs(hx-nx)
      fullrad = 2*halfrad
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2real_out(x,y,'(#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_integer_out(halfrad,'halfrad')
        call str_integer_out(fullrad,'fullrad')
        call str_grad_out(start,'start=#')
        call str_grad_out(size,'size=#')
      endif
      if(fullrad.le.0) then
        call wdrawpoint(nx,ny)
      else
        call wdrawarc(nx-halfrad,ny-halfrad,fullrad,fullrad,
     +       nint(start*grad),nint(size*grad))
      endif
      return
      end                       ! DrawArc
      subroutine DrawCenteredString(x,y,position,s)
      real      x
      real      y
      character position*(*)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawCenteredString')
      integer   nx
      integer   ny
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x,y,nx,ny,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x,y,nx,ny)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2real_out(x,y,'(#,#)')
      endif
      call DrawWindowCenteredString(nx,ny,position,s)
      return
      end                       ! DrawCenteredString
      subroutine DrawCircle(x,y,radius)
      real      x
      real      y
      real      radius
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      real      TwoPi
      parameter (TwoPi=2*3.1415927)
      call DrawArc(x,y,radius,0.0,TwoPi)
      return
      end                       ! DrawCircle
      subroutine DrawFatPoint(x,y,n)
      real      x
      real      y
      integer   n
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawFatPoint')
      integer   px
      integer   py
      integer   n1
      integer   n2
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      if(n.le.1) then
        call DrawPoint(x,y)
      else
        call WorldToWindow(x,y,px,py,ier)
        if(ier.ne.0) then
          call WorldToWindowError(ROUTINE,x,y,px,py)
          return
        endif
        call ClearPoint(1)
        n1 = -(n-1)/2
        n2 = n1+n  ! -1+1 Note fill leaves out bottom and right side
        if(loglevel.ge.wLogDebug) then
          call str_out(ROUTINE)
          call str_integer_out(n,'#')
          call str_2real_out(x,y,'(#,#)')
          call str_2integer_out(px,py,'[#,#]')
        endif
        call AddWindowPoint(px+n1,py+n1)
        call AddWindowPoint(px+n2,py+n1)
        call AddWindowPoint(px+n2,py+n2)
        call AddWindowPoint(px+n1,py+n2)
        call FillPolygon
      endif
      return
      end                       ! DrawFatPoint
      subroutine DrawLine(x1,y1,x2,y2)
      real      x1
      real      y1
      real      x2
      real      y2
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawLine')
      integer   nx1
      integer   ny1
      integer   nx2
      integer   ny2
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x1,y1,nx1,ny1,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x1,y1,nx1,ny1)
        return
      endif
      if(ier.eq.0) call WorldToWindow(x2,y2,nx2,ny2,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x2,y2,nx2,ny2)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2real_out(x1,y1,'(#,#)')
        call str_2real_out(x2,y2,'- (#,#)')
        call str_2integer_out(nx1,ny1,'[#,#]')
        call str_2integer_out(nx2,ny2,'- [#,#]')
      endif
      call wdrawline(nx1,ny1,nx2,ny2)
      return
      end                       ! DrawLine
      subroutine DrawPoint(x,y)
      real      x
      real      y
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawPoint')
      integer   nx
      integer   ny
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x,y,nx,ny,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x,y,nx,ny)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2real_out(x,y,'(#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
      endif
      call wdrawpoint(nx,ny)
      return
      end                       ! DrawPoint
      subroutine DrawString(x,y,s)
      real      x
      real      y
      character s*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   length
      character ROUTINE*(*)
      parameter (ROUTINE='DrawString')
      integer   nx
      integer   ny
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x,y,nx,ny,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x,y,nx,ny)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2real_out(x,y,' (#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_string_out(s,'"#"')
      endif
      if(ier.ne.0) return
      call wdrawstring(nx,ny,length(s),s)
      return
      end                       ! DrawString
      subroutine DrawWindowCenteredString(x,y,position,s)
      integer   x
      integer   y
      character position*(*)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   length
      character ROUTINE*(*)
      parameter (ROUTINE='DrawWindowCenteredString')
      integer   positioncode
      character upos*2
      if(ActiveWindow.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2integer_out(x,y,'[#,#]')
        call str_string_out(s,'"#"')
      endif
      call upcase(position,upos)
      if(upos.eq.' ') then
        positioncode = 0
      else if(upos.eq.'N') then
        positioncode = 1
      else if(upos.eq.'NE'.or.upos.eq.'EN') then
        positioncode = 2
      else if(upos.eq.'E') then
        positioncode = 3
      else if(upos.eq.'SE'.or.upos.eq.'ES') then
        positioncode = 4
      else if(upos.eq.'S') then
        positioncode = 5
      else if(upos.eq.'SW'.or.upos.eq.'WS') then
        positioncode = 6
      else if(upos.eq.'W') then
        positioncode = 7
      else if(upos.eq.'NW'.or.upos.eq.'WN') then
        positioncode = 8
      else
        positioncode = 0
      endif
      call wdrawcenteredstring(x,y,positioncode,length(s),s)
      return
      end                       ! DrawWindowCenteredString
      subroutine DrawWindowLines
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawWindowLines')
      integer   space
      integer   i1
      integer   i2
      if(ActiveWindow.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_integer_out(ipoint,'#')
      endif
      if(ipoint.gt.0) then
        space = (RequestSize-3)/2
        i1 = 1
        do while(i1.le.ipoint)
          i2 = i1 + space
          if(i2.gt.ipoint) i2 = ipoint
          call wdrawlines(i2-i1+1,pointxy(i1))
          if(i2.lt.ipoint) then
            i1 = i2  ! connect lines
          else
            i1 = ipoint + 1
          endif
        enddo
      endif
      return
      end                       ! DrawWindowLines
      subroutine DrawWindowPoints
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='DrawWindowPoints')
      integer   space
      integer   i1
      integer   i2
      if(ActiveWindow.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_integer_out(ipoint,'#')
      endif
      if(ipoint.gt.0) then
        space = (RequestSize-3)
        i1 = 1
        do while(i1.le.ipoint)
          i2 = i1 + space
          if(i2.gt.ipoint) i2 = ipoint
          call wdrawpoints(i2-i1+1,pointxy(i1))
          i1 = i2 + 1
        enddo
      endif
      return
      end                       ! DrawWindowPoints
      subroutine FillArc(x,y,radius,start,size)
      real      x
      real      y
      real      radius
      real      start           ! radians
      real      size            ! radians
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='FillArc')
      real      Pi
      real      Grad
      parameter (Pi=3.1415927)
      parameter (Grad = 180.0/Pi)
      integer   nx
      integer   ny
      integer   hx
      integer   hy
      integer   halfrad
      integer   fullrad
      integer   ier
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call WorldToWindow(x,y,nx,ny,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x,y,nx,ny)
        return
      endif
      call WorldToWindow(x+radius,y,hx,hy,ier)
      if(ier.ne.0) then
        call WorldToWindowError(ROUTINE,x+radius,y,hx,hy)
        return
      endif
      halfrad = abs(hx-nx)
      fullrad = 2*halfrad
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2real_out(x,y,'(#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_integer_out(fullrad,'fullrad')
      endif
      if(fullrad.le.0) then
        call wdrawpoint(nx,ny)
      else
        call wfillarc(nx-halfrad,ny-halfrad,fullrad,fullrad,
     +       nint(start*grad*64),nint(size*grad*64))
      endif
      return
      end                       ! FillArc
      subroutine FillCircle(x,y,radius)
      real      x
      real      y
      real      radius
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      real      TwoPi
      parameter (TwoPi=2*3.1415927)
      call FillArc(x,y,radius,0.0,TwoPi)
      return
      end                       ! FillCircle
      subroutine FillPolygon
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='FillPolygon')
      if(ActiveWorld.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_integer_out(ipoint,'#')
        call ListPixel
      endif
      if(ipoint.gt.0) then
        call wfillpolygon(ipoint,pointxy(1))  ! No Requestsize?
      endif
      return
      end                       ! FillPolygon
      subroutine GetColour(colourname,colourcode)
      character colourname*(*)
      integer   colourcode
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='GetColour')
      character s*80
      character lcname*80
      integer   ls
      integer   r
      integer   g
      integer   b
      if(loglevel.ge.wLogInfo) then
        call str_out(ROUTINE)
        call str_out(colourname)
      endif
      call lowercase(colourname,lcname)
      if(lcname.eq.lastcolourname) then
        colourcode = lastcolourcode
        if(loglevel.ge.wLogInfo) then
          call str_out('identical.')
        endif
      else
        if(lcname.eq.'none') then
          colourcode = -1
        else
          call str_zero(lcname,s,ls)
          call wgetcolour(s(1:ls),colourcode,r,g,b)
          if(colourcode.lt.0) then
            if(loglevel.ge.wLogErr) then
              call str_out('Cannot get colour')
              call str_out(lcname)
            endif
          endif
        endif
        if(colourcode.ge.0) then
          if(loglevel.ge.wLogInfo) then
            call str_integer_out(colourcode,'code=#')
            write(s,110) r/256,g/256,b/256,r/256,g/256,b/256
  110       format('#',3z2.2,3i4)
            call str_out(s)
          endif
          if(ColourInvert) then
            write(s,100) 65535-r,65535-g,65535-b
  100       format('#',3z4.4)
            call str_zero(s,s,ls)
            call wgetcolour(s(1:ls),colourcode,r,g,b)
            if(loglevel.ge.wLogInfo) then
              call str_integer_out(colourcode,'invertedcode=#')
              write(s,110) r/256,g/256,b/256
              call str_out(s)
            endif
          endif
          lastcolourname = lcname
          lastcolourcode = colourcode
        endif
      endif
      return
      end                       ! GetColour
      subroutine GetWindowId(windownr,result)
      integer   windownr
      integer   result
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(.not.WindowUsed(WindowNr)) then
        result = -1
      else
        call wwindowid(windownr,result)
      endif
      return
      end                       ! GetWindowId
      subroutine GetWindowLog(n,m)
      integer   n
      integer   m
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      n = loglevel
      m = wLogDebug
      return
      end                       ! GetWindowLog
      subroutine GetWindowStatus(n,status)
      integer   n
      integer   status  ! -1=error 0=exists 1=possible
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(n.le.0.or.n.gt.maxWindow) then
        status = -1
      else if(.not.WindowUsed(n)) then
        status = 1
      else
        status = 0
      endif
      return
      end                       ! GetWindowStatus
      subroutine InitWindow(ier)
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   i
      character displayname*80
      character s*80
      integer   ls
      if(.not.display_activated) then
        do i=1,MaxWindow
          WindowUsed(i) = .false.
        enddo
        do i=1,MaxWorld
          WorldParent(i) = 0
        enddo
        lastfontname = '9x15'
        call str_zero(lastfontname,s,ls)
        call winit(s(1:ls),ier,ScreenWidth,ScreenHeight,
     +       requestsize,displaytype)
        if(ier.eq.1) then
          call windowlog(wLogErr,'Cannot open display')
          call get_symbol('DISPLAY',displayname)
          call str_out(displayname)
          return
        else if(ier.eq.2) then
          call windowlog(wLogErr,'Cannot load font')
          call str_out(lastfontname)
        endif
        if(ier.eq.0) then
          display_activated = .True.
        endif
        if(loglevel.ge.wLogInfo) then
          call str_integer_out(DisplayType,'DisplayType=#')
          if(DisplayType.eq.1) then
            call get_symbol('DISPLAY',displayname)
            call str_string_out(displayname,'Display # opened')
          endif
          call str_2integer_out(ScreenWidth,ScreenHeight,
     +         'Screen Width=# Height=#')
          call str_integer_out(requestsize,'requestsize=#.')
        endif
        ActiveWorld = -1
        ActiveWindow = -1
        LastColourCode = -1
        LastColourName = ' '
        LastColourSet = -1
        ColourInvert = .false.
        LineWidth = 0
        LineStyle = 0
      else
        ier = 0
      endif
      return
      end                       ! InitWindow
      subroutine ListPixel
      integer   i
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   nx
      integer   ny
      if(ipoint.eq.0) return
      call str_flush
      do i=1,ipoint
        nx = pointxy(2*i-1)
        ny = pointxy(2*i)
        write (6,600) i,nx,ny
600     format(3i5)
      enddo
      return
      end                       ! ListPixel
      subroutine MapPixmap(pnr,ier)
      integer   pnr
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='MapPixmap')
      integer   wnr
      call CheckPixmapNr(pnr,ROUTINE,ier)
      if(ier.ne.0) return
      wnr = WindowParent(pnr)
      if(loglevel.ge.wLogNotice) then
        call str_out(ROUTINE)
        call str_2integer_out(pnr,wnr,'# on window #.')
      endif
      call wmappixmap(pnr,wnr,WindowWidth(pnr),WindowHeight(pnr))
      ier = 0
      return
      end                       ! MapPixmap
      subroutine MapWindow(wnr,ier)
      integer   wnr
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='MapWindow')
      call CheckWindowNr(wnr,ROUTINE,ier)
      if(ier.ne.0) return
      if(loglevel.ge.wLogNotice) then
        call str_out(ROUTINE)
        call str_integer_out(wnr,'#.')
      endif
      ier = 0
      call wmap(wnr)
      call WindowFlush
      return
      end                       ! MapWindow
      subroutine ResizeWindow(w,h)
      integer   w
      integer   h
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='ResizeWindow')
      integer   i
      real      fx
      real      fy
      integer   shift
      if(ActiveWindow.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      if(loglevel.ge.wLogNotice) then
        call str_out(ROUTINE)
        call str_integer_out(ActiveWindow,'#')
        call str_2integer_out(w,h,'w=# h=#.')
        call str_flush
      endif
      fx = float(w-1)/(WindowWidth(ActiveWindow)-1)
      fy = float(h-1)/(WindowHeight(ActiveWindow)-1)
      do i=1,maxworld
        if(WorldParent(i).eq.ActiveWindow) then
          scalx(i) = fx*scalx(i)
          scaly(i) = fx*scaly(i)
        endif
      enddo
      shift = h - WindowHeight(ActiveWindow)
      WindowVerX(ActiveWindow) = WindowVerX(ActiveWindow) - shift
      WindowWidth(ActiveWindow) = w
      WindowHeight(ActiveWindow) = h
      call wresize(WindowWidth(ActiveWindow),WindowHeight(ActiveWindow))
      return
      end                       ! ResizeWindow
      subroutine ScreenDimensions(x,y,Hardlimit)
      integer   x
      integer   y
      logical   HardLimit
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   ier
      call InitWindow(ier)
      if(ier.ne.0) then
        x = 0
        y = 0
        HardLimit = .true.
      else
        x = ScreenWidth
        y = ScreenHeight
        HardLimit = (DisplayType.eq.1)
      endif
      if(loglevel.ge.wLogDebug) then
        call str_2integer_out(x,y,'Screendimensions #,#')
      endif
      return
      end                       ! ScreenDimensions
      subroutine SetColourDirect(colourcode)
      integer   colourcode
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='SetColourDirect')
      if(colourcode.ne.lastcolourset) then
        if(loglevel.ge.wLogInfo) then
          call str_out(ROUTINE)
          call str_integer_out(colourcode,'#')
        endif
        call wsetcolour(colourcode)
        lastcolourset = colourcode
      else
        if(loglevel.ge.wLogDebug) then
          call str_out(ROUTINE)
          call str_integer_out(colourcode,'# identical.')
        endif
      endif
      return
      end                       ! SetColourDirect
      subroutine SetWindowLog(n)
      integer   n
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(n.ge.wLogEmerg.and.n.le.wLogDebug) then
        loglevel = n
        call windowloginteger(wLOgInfo,n,'Window loglevel=#.')
      else
        call windowloginteger(wLOgErr,n,'SetWindowLog: # out of range.')
      endif
      return
      end                       ! SetWindowLog
      subroutine StringSize(s,width,height)
      character s*(*)
      real      width
      real      height
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      character ROUTINE*(*)
      parameter (ROUTINE='StringSize')
      integer   length
      integer   w
      integer   h
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      call wstringsize(length(s),s,w,h)
      width = w/scalx(ActiveWorld)
      height = h/scaly(ActiveWorld)
      if(loglevel.ge.wLogDebug) then
        call str_out(ROUTINE)
        call str_2integer_out(w,h,'[#,#]')
        call str_2real_out(width,height,'(#,#)')
        call str_string_out(s,'"#"')
      endif
      return
      end                       ! StringSize
      subroutine WindowCannot(s)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(loglevel.ge.wLogErr) then
        call str_string_out(s,'Cannot #. Inactive World.')
      endif
      return
      end                       ! WindowCannot
      block data windowdata
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      data display_activated /.false./
      data loglevel /wLogWarning/
      data ActiveWindow,ActiveWorld /-1,-1/
      end
      subroutine WindowExit
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   i
      if(display_activated) then
        do i=1,maxwindow
          if(WindowUsed(i).and.WindowParent(i).eq.0) then
            call wclose(i)
          endif
        enddo
      endif
      return
      end                       ! WindowExit
      subroutine WindowFlush
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      character ROUTINE*(*)
      parameter (ROUTINE='WindowFlush')
      if(loglevel.ge.wLogNotice) then
        call str_out(ROUTINE)
      endif
      call wflush
      return
      end                       ! WindowFlush
      subroutine WindowInfo(unit,n)
      integer   unit
      integer   n
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   i
      if(.not.display_activated) then
        call windowloginteger(wLOgErr,n,
     +       'WindowInfo: dislay not activated.')
        return
      endif
      if(n.lt.0.or.n.gt.maxwindow) then  ! NB lt and not le
        call windowloginteger(wLOgErr,n,
     +       'WindowInfo: nr # out of range.')
        return
      endif
      call str_unit_push(unit)
      call wdisplayinfo
      if(n.eq.0) then
        do i=1,MaxWindow
          if(WindowUsed(i)) then
            call WindowOneInfo(i)
          endif
        enddo
      else
        call WindowOneInfo(n)
      endif
      call str_unit_pop
      return
      end                       ! WindowInfo
      subroutine WindowLog(level,message)
      integer   level
      character message*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(loglevel.ge.level) then
        call str_out(message)
      endif
      return
      end                       ! WindowLog
      subroutine WindowLogError(calledfrom,n,message)
      character calledfrom*(*)
      integer   n
      character message*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(loglevel.ge.wLogErr) then
        call str_out(calledfrom)
        call str_integer_out(n,message)
      endif
      return
      end                       ! WindowLogError
      subroutine WindowLogInteger(level,n,message)
      integer   level
      integer   n
      character message*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(loglevel.ge.level) then
        call str_integer_out(n,message)
      endif
      return
      end                       ! WindowLogInter
      subroutine WindowOneInfo(n)
      integer   n
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      integer   j
      integer   ndaughter
      if(WindowUsed(n)) then
        if(IsPixmap(n)) then
          call str_integer_out(n,'Pixmap #')
        else
          call str_integer_out(n,'Window #')
        endif
        call str_integer_out(WindowParent(n),'Parent=#')
        if(.not.IsPixmap(n)) then
          call str_integer_out(WindowBorder(n),'Border=#')
          call str_integer_out(WindowHor(n),'Hor=#')
          call str_integer_out(WindowVer(n),'Ver=#')
          call str_integer_out(WindowVerX(n),'VerX=#')
        endif
        call str_integer_out(WindowWidth(n),'Width=#')
        call str_integer_out(WindowHeight(n),'Height=#')
        call str_integer_out(WindowBG(n),'BG=#')
        if(n.eq.activewindow) call str_out('Active')
        call str_flush
        ndaughter = 0
        do j=1,MaxWindow
          if(WindowUsed(j)) then
            if(WindowParent(j).eq.n) then
              if(ndaughter.eq.0) call str_out('Daughters:')
              call str_integer_out(j,'#')
              ndaughter = ndaughter + 1
            endif
          endif
        enddo
        if(ndaughter.gt.0) call str_flush
        if(.not.IsPixmap(n)) then
          call winfo(n)
        endif
        do j=1,MaxWorld
          if(WorldParent(j).eq.n) then
            call str_integer_out(j,'World #:')
            call str_real_out(offsx(j),'Offset hor=#')
            call str_real_out(offsy(j),'ver=#.')
            call str_real_out(scalx(j),'Scale hor=#')
            call str_real_out(scaly(j),'ver=#.')
            if(j.eq.ActiveWorld) call str_out('Active')
            call str_flush
          endif
        enddo
      endif
      return
      end                       ! WindowOneInfo
      subroutine WindowPs(name,windownr,DoRotate,extra,message,ier)
      character name*(*)
      integer   windownr
      logical   DoRotate
      character extra*(*)
      character message*(*)
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='WindowPs')
      logical   WindowPsPossible
      integer   id
      character filename*80
      integer   lf
      character command*256
      character option*80
      integer   border
      if(DisplayType.ne.1) then
        call str_string(ROUTINE,
     +       '#: Not a real display. No import possible',message)
        ier = 0
        return
      endif
      if(loglevel.ge.wLogNotice) then
        call str_out(ROUTINE)
        call str_integer_out(windownr,'Window=#')
      endif
      call GetWindowId(windownr,id)
      if(id.lt.0) then
        call WindowLogError(ROUTINE,windownr,
     +       'cannot get windowid of #.')
        ier = 1
        goto 800
      endif
      if(.not.WindowPsPossible()) then
        call str_string(ROUTINE,'#: import program not found',
     +       message)
        call WindowLog(wLogErr,message)
        ier = 1
        goto 800
      endif
      if(loglevel.ge.wLogInfo) then
        call str_integer_out(id,'WindowId=#')
      endif
      command = 'import -verbose -page a4 #'
      if(WindowParent(windownr).ne.0.and..false.) then
        call GetWindowId(WindowParent(windownr),id)
        if(loglevel.ge.wLogInfo) then
          call str_integer_out(WindowParent(windownr),'Parent=#')
          call str_integer_out(id,'ParentId=#')
        endif
        if(loglevel.ge.wLogInfo) then
          call str_integer_out(WindowWidth(windownr),'Width=#')
          call str_integer_out(WindowHeight(windownr),'Height=#')
          call str_integer_out(WindowHor(windownr),'Hor=#')
          call str_integer_out(WindowVerX(windownr),'VerX=#')
        endif
        option = '-crop #x#+#+#'
        border = windowBorder(windownr)
        call str_integer(WindowWidth(windownr),option,option)
        call str_integer(WindowHeight(windownr),option,option)
        call str_integer(WindowHor(windownr)+border,option,option)
        call str_integer(WindowVerX(windownr)+border,option,option)
        call str_2string(command,option,'# #',command)
      endif
      call build_file(name,'import','.ps',filename,lf)
      call rename_unique_file(filename,message,ier)
      if(ier.ne.0) then
        call WindowLog(wLogErr,message)
        return
      endif
      if(DoRotate) then
        option = '-rotate "+90>"'
        call str_2string(command,option,'# #',command)
      endif
      call str_2string(command,extra,'# #',command)
      option = '-window'
      call str_2string(command,option,'# #',command)
      call str_integer(id,command,command)
      call str_string(filename,command,command)
      if(loglevel.ge.wLogNotice) then
        call str_out(command)
      endif
      call str_flush
      call spawn(command,ier)
      ier = 0
      call str_string(filename,'Created #',message)
 800  continue
      if(ier.ne.0) then
        call str_string(ROUTINE,'# failed',message)
      endif
      return
      end                       ! WindowPs
      logical function WindowPsPossible()
      character prog*80
      character message*256
      integer   ier
      call which('import',prog,message,ier)
      WindowPsPossible = (ier.eq.0)
      return
      end                       ! WindowPsPossible
      subroutine WindowSync
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      character ROUTINE*(*)
      parameter (ROUTINE='WindowSync')
      integer   length
      character fn*80
      integer   lfn
      integer   n
      if(loglevel.ge.wLogNotice) then
        call str_out(ROUTINE)
      endif
      call get_logical('NAMEGD',fn)
      if(length(fn).eq.0) then
        call image_name(fn,lfn)
      endif
      if(loglevel.ge.wLogNotice) then
        call str_out(fn)
      endif
      call str_flush
      call str_zero(fn,fn,lfn)
      call wsync(fn(1:lfn),n)
      if(loglevel.ge.wLogNotice) then
        call str_integer_out(n,'windowsync #')
      endif
      return
      end                       ! WindowSync
      subroutine WindowTitle(s)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='WindowTitle')
      character title*256
      integer   lt
      integer   i
      integer   ier
      integer   KeepActiveWorld
      integer   KeepActiveWindow
      logical   activechanged
      if(ActiveWindow.lt.0) then
        call WindowCannot(ROUTINE)
        return
      endif
      call str_zero(s,title,lt)
      i = ActiveWindow ! WorldParent(ActiveWorld)
      do while(WindowParent(i).gt.0)
        i = WindowParent(i)
      enddo
      if(i.ne.ActiveWindow) then
        KeepActiveWorld = ActiveWorld
        KeepActiveWindow = ActiveWindow
        call ActivateWindow(i,ier)
        ActiveChanged = .true.
      else
        ActiveChanged = .false.
        ier = 0
      endif
      if(ier.eq.0) then
        if(loglevel.ge.wLogInfo) then
          call str_out(ROUTINE)
          call str_integer_out(i,'Window #')
          call str_string_out(s,'title=#')
        endif
        call wtitle(title(1:lt))
      endif
      if(ActiveChanged) then
        if(KeepActiveWorld.gt.0) then
          activeworld = -1
          call ActivateWorld(KeepActiveWorld,ier)
        else
          if(KeepActiveWindow.gt.0) then
            ActiveWindow = -1
            call ActivateWindow(KeepActiveWindow,ier)
          endif
        endif
      endif
      return
      end                       ! WindowTitle
      subroutine WorldCannot(s)
      character s*(*)
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      if(loglevel.ge.wLogErr) then
        call str_string_out(s,'Cannot #. Inactive World.')
      endif
      return
      end                       ! WorldCannot
      subroutine WorldToWindow(x,y,nx,ny,ier)
      real      x
      real      y
      integer   nx
      integer   ny
      integer   ier
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      external windowdata
      character ROUTINE*(*)
      parameter (ROUTINE='WorldToWindow')
      integer   w
      if(ActiveWorld.lt.0) then
        call WorldCannot(ROUTINE)
        return
      endif
      nx = nint(scalx(ActiveWorld)*(x-offsx(ActiveWorld)))
      ny = nint(scaly(ActiveWorld)*(y-offsy(ActiveWorld)))
      if(abs(nx).lt.65535.and.abs(ny).lt.65535) then
        ier = 0
      else
        ier = 1
      endif
      w = WorldParent(ActiveWorld)
      ny = (WindowHeight(w)- ny)-1
      return
      end                       ! WorldToWindow
      subroutine WorldToWindowError(name,x,y,nx,ny)
      character name*(*)
      real      x
      real      y
      integer   nx
      integer   ny
      integer maxwindow
      parameter (maxwindow=500)  ! nb ook veranderen in winx.c en wingd.c
      integer maxworld
      parameter (maxworld=maxwindow)
      integer wLogEmerg
      integer wLogAlert
      integer wLogCrit
      integer wLogErr
      integer wLogWarning
      integer wLogNotice
      integer wLogInfo
      integer wLogDebug
      parameter(wLogEmerg=0)
      parameter(wLogAlert=1)
      parameter(wLogCrit=2)
      parameter(wLogErr=3)
      parameter(wLogWarning=4)
      parameter(wLogNotice=5)
      parameter(wLogInfo=6)
      parameter(wLogDebug=7)
      real    scalx(maxworld)
      real    scaly(maxworld)
      real    offsx(maxworld)
      real    offsy(maxworld)
      real    topx(maxworld)
      real    topy(maxworld)
      integer WorldParent(maxworld)
      logical WindowUsed(maxwindow)
      integer WindowHor(maxwindow)
      integer WindowVer(maxwindow)
      integer WindowVerX(maxwindow)
      integer WindowWidth(maxwindow)
      integer WindowHeight(maxwindow)
      integer WindowBG(maxwindow)
      integer WindowParent(maxwindow)
      integer WindowBorder(maxwindow)
      logical IsPixmap(maxwindow)
      integer ScreenWidth,ScreenHeight
      integer lastcolourcode
      integer lastcolourset
      logical ColourInvert
      integer RequestSize
      logical WithEventLoop
      integer DisplayType
      integer LineWidth
      integer LineStyle
      common /CommonWindow/ scalx,scaly,offsx,offsy,
     +     topx,topy,WorldParent,WindowUsed,
     +     WindowHor,WindowVer,WindowVerx,WindowWidth,WindowHeight,
     +     WindowBG,WindowParent,WindowBorder,IsPixmap,
     +     ScreenWidth,ScreenHeight,lastcolourcode,lastcolourset,
     +     colourinvert,RequestSize,WithEventLoop,DisplayType,
     +     LineWidth,LineStyle
      character lastcolourname*80
      character lastfontname*80
      common /CommonWindowChar/ lastcolourname,lastfontname
      logical display_activated
      integer loglevel
      integer ActiveWindow
      integer ActiveWorld
      common /CommonWindowData/ display_activated,loglevel,
     + ActiveWindow,ActiveWorld
      integer maxpoint
      parameter (maxpoint=1000)
      integer PointMode
      integer ipoint
      integer*2 pointxy(2*maxpoint)
      integer*2 firstpoint(2)
      common /window_points/ PointMode,ipoint,pointxy,firstpoint
      if(loglevel.ge.wLogWarning) then
        call str_out(name)
        call str_2real_out(x,y,'(#,#)')
        call str_2integer_out(nx,ny,'[#,#]')
        call str_out('IntegerOverflow.')
      endif
      return
      end                       ! WorldToWindowError
